#include <owl\applicat.h>
#include <owl\framewin.h>
#include <owl\dialog.h>
#include <owl\dc.h>
#include <owl\edit.h>
#include <owl\validate.h>
#include "pr22_1.rc"

//   .
struct TTransBuf
{
  char nameEdit[81];
  char addrEdit[81];
  char cityEdit[81];
  char stateEdit[3];
  char zipEdit[11];
  char phoneEdit[20];
  char birthEdit[9];
};

//  .
TTransBuf transBuf;


// 
class TApp: public TApplication
{
  public:
	 TApp():TApplication(){}
	 void InitMainWindow();
};

//  
class TWndw:public TFrameWindow
{
  public:
	 TWndw(TWindow *parent, const char far *title);
  protected:
	 void CmTestDialog();
	 void Paint(TDC &paintDC,BOOL,TRect&);

	 DECLARE_RESPONSE_TABLE (TWndw);
};

DEFINE_RESPONSE_TABLE1 (TWndw, TFrameWindow)
  EV_COMMAND(CM_TESTDIALOG,CmTestDialog),
END_RESPONSE_TABLE;

//  
class TDlg:public TDialog
{
  protected:
	  TTransBuf oldTransBuf;
  public:
	  TDlg(TWindow *parent, TResId resld);
  protected:
	  void SetupWindow();
	  BOOL CanClose();
	  void CmCancel();

	  DECLARE_RESPONSE_TABLE(TDlg);
};

DEFINE_RESPONSE_TABLE1(TDlg, TDialog)
  EV_COMMAND(IDCANCEL, CmCancel),
END_RESPONSE_TABLE;


TWndw::TWndw(TWindow *parent, const char far *title):
		  TFrameWindow(parent,title)
{
	//     .
	AssignMenu("MENU_1");
	//     .
	Attr.X=50;
	Attr.Y=50;
	Attr.W=GetSystemMetrics(SM_CXSCREEN)/3;
	Attr.H=GetSystemMetrics(SM_CXSCREEN)/4;
	//   .
	memset (&transBuf, 0, sizeof(transBuf));
}

// TWndw::CmTestDialog()
//      Dialog/Test
//  Dialog.
void TWndw::CmTestDialog()
{
  //   .
  TDialog *dialog = new TDlg(this, ADDRDLG);
  //   .
  int result = dialog->Execute();
  //     ... 
  if (result == IDOK)
     //    
     //     . 
     Invalidate();
}

//TWndw::Paint()
//    
// TWindow Paint(),    WM_PAINT,
//  Windows    , 
//   .
void TWndw::Paint(TDC &paintDC,BOOL,TRect&)
{
  TEXTMETRIC tm;
  //   .
  paintDC.GetTextMetrics(tm);
  //    .
  paintDC.SetTextAlign(TA_RIGHT);
  //    
  TSize size=paintDC.GetTextExtent("BIRTHDAY:",9);
  //      
  paintDC.TextOut(size.cx+12,tm.tmHeight,"NAME:");
  paintDC.TextOut(size.cx+12,tm.tmHeight*2,"ADDRESS:");
  paintDC.TextOut(size.cx+12,tm.tmHeight*3,"CITY:");
  paintDC.TextOut(size.cx+12,tm.tmHeight*4,"STATE:");
  paintDC.TextOut(size.cx+12,tm.tmHeight*5,"ZIP:");
  paintDC.TextOut(size.cx+12,tm.tmHeight*6,"PHONE:");
  paintDC.TextOut(size.cx+12,tm.tmHeight*7,"BIRTHDAY:");
  //    	 .
  paintDC.SetTextAlign(TA_LEFT);
  //    
  //   ,
  //         .
  paintDC.TextOut(size.cx+20,tm.tmHeight,transBuf.nameEdit);
  paintDC.TextOut(size.cx+20,tm.tmHeight*2,transBuf.addrEdit);
  paintDC.TextOut(size.cx+20,tm.tmHeight*3,transBuf.cityEdit);
  paintDC.TextOut(size.cx+20,tm.tmHeight*4,transBuf.stateEdit);
  paintDC.TextOut(size.cx+20,tm.tmHeight*5,transBuf.zipEdit);
  paintDC.TextOut(size.cx+20,tm.tmHeight*6,transBuf.phoneEdit);
  paintDC.TextOut(size.cx+20,tm.tmHeight*7,transBuf.birthEdit);
}

// ************************
//   TDlg.
// ************************
// TDlg::TDlg()
//   .
TDlg::TDlg(TWindow *parent,TResId resId):
			TDialog(parent,resId)
{
  TEdit *edit;
  TValidator  *valid;

  //     OWL   
  //       ,   
  //     ,      
  // -  
  // ,          .
  new TEdit(this,ID_NAME,sizeof(transBuf.nameEdit));
  new TEdit(this,ID_ADDR,sizeof(transBuf.addrEdit));
  new TEdit(this,ID_CITY,sizeof(transBuf.cityEdit));
  edit = new TEdit(this, ID_STATE, sizeof(transBuf.stateEdit));
  valid = new  TFilterValidator("-");
  edit->SetValidator(valid);
  edit = new TEdit(this,ID_ZIP,sizeof(transBuf.zipEdit));
  valid = new TFilterValidator("0-9-") ;
  edit->SetValidator(valid);
  edit = new TEdit(this, ID_PHONE, sizeof(transBuf.phoneEdit));
  valid = new TPXPictureValidator("##-##-##");
  edit->SetValidator(valid);
  edit = new TEdit(this, ID_BIRTH,sizeof (transBuf.birthEdit));
  valid = new TPXPictureValidator("##.##");
  edit->SetValidator(valid);
  //    .
  TransferBuffer=&transBuf;
}

// TDlg::SetupWindow()
//    SetupWindow() 
// TDialog     
//   .    
//  .
void TDlg::SetupWindow()
{
  // !    .
  TDialog::SetupWindow();
  //      
  // ,       Cancel.
  memcpy(&oldTransBuf, &transBuf, sizeof(transBuf));
}

// TDlg::CanClose()
//
//  ,   
// TWindows,   
//    
//  .
BOOL TDlg::CanClose()
{
  //     .
  TransferData(tdGetData);
  // ,     
  //       .
  if ((strlen(transBuf.nameEdit) == 0) ||
	  (strlen(transBuf.addrEdit) == 0) ||
	  (strlen(transBuf.cityEdit) == 0) ||
	  (strlen(transBuf.stateEdit) != 2) ||
	  (strlen(transBuf.zipEdit) < 5))
	{
	  //   ,  
	  //     
	  //     .
	  MessageBox ("   .", "", MB_OK | MB_ICONEXCLAMATION);
	  return FALSE; }
	else
		 //    ,    .
  return TRUE;
}

// TDlg::CmCancel()
//     
// TDialog,     Cancel
//  ,   
//   .
void TDlg::CmCancel()
{
  //   .
  memcpy(&transBuf, &oldTransBuf, sizeof(oldTransBuf));
  //     CmCansel().
  TDialog::CmCancel();
}

void TApp::InitMainWindow()
{
  TFrameWindow *wndw= new TWndw(0,"   ");
  SetMainWindow(wndw);
  //   DLL 
  //    Borland.
  EnableBWCC();
}

int OwlMain(int,char *[])
{
  return TApp().Run();
}
